import { Client, Events, GatewayIntentBits, Partials } from "discord.js";
import config from "./config";
import { linusType } from "./keyboard";
import crypto from 'node:crypto';
import delay from "delay";
import fsp from 'node:fs/promises';

const client = new Client({
    intents: [
        GatewayIntentBits.DirectMessages,
        GatewayIntentBits.MessageContent,
        GatewayIntentBits.DirectMessageTyping
    ],
    partials: [
        Partials.Channel,
        Partials.Message
    ]
});

client.on(Events.ClientReady, async readyClient => {
    console.log(`Logged in as ${readyClient.user.tag}`);
});

client.on(Events.MessageCreate, async interaction => {
    if (interaction.author.bot) {
        return;
    }
    
    if (!interaction.resolved) {
        const max = crypto.randomInt(2) + 1;
        for (let i = 0; i != max; i++) {
            await interaction.channel.sendTyping();
            await interaction.channel.send(linusType());
            if (i != max) {
                await interaction.channel.sendTyping();
                await delay(crypto.randomInt(1000) + 500);
            }
        }
    }
});

await client.login(config.key);
