import crypto from 'node:crypto';

export const keyboard = Object.freeze([
    '`1234567890-='.split(''),
    'qwertyuiop[]\\789+'.split(''),
    [ 'CAPS', ...'asdfghjkl;'.split('') ],
    [ 'CAPS', ...'zxcvbnm,/'.split('') ]
]);

export function linusType() {
    const lengths = [
        2,
        6,
        crypto.randomInt(10) + 10,
        crypto.randomInt(10) + 15,
        crypto.randomInt(10) + 20,
        crypto.randomInt(5) + 5,
        crypto.randomInt(5) + 10,
        crypto.randomInt(5) + 15,
    ];
    const thisLen = lengths[crypto.randomInt(lengths.length)];

    function maxX() {
        if (keyboard[y] === undefined) {
            y = maxY() - 1;
        }
        return keyboard[y].length;
    }
    function maxY() {
        return keyboard.length;
    }

    let [x, y] = [0, crypto.randomInt(keyboard.length)];
    x = crypto.randomInt(maxX());

    let yChance = 2;
    let xChance = 2;

    let yDirectionRight = crypto.randomInt(1) === 1;
    let xDirectionRight = crypto.randomInt(1) === 1;

    let caps = crypto.randomInt(1) === 1;

    let out = '';

    while (out.length < thisLen) {
        if (y == maxY()) {
            y = maxY() - 1;
            yDirectionRight = false;
        }
        if (y < 0) {
            y = 0;
            yDirectionRight = true;
        }
        if (x >= maxX()) {
            x = maxX() - 1;
            xDirectionRight = false;
        }
        if (x < 0) {
            x = 0;
            xDirectionRight = true;
        }

        let thisChar = keyboard[y][x];
        if (thisChar === 'CAPS') {
            caps = !caps;
            x = xDirectionRight ? (x + 1) : (x - 1);
            continue;
        }

        if (caps) {
            thisChar = thisChar.toUpperCase();
        }
        
        out += thisChar;

        if (crypto.randomInt(yChance) == 1) {
            y = yDirectionRight ? (y + 1) : (y - 1);
            if (y == 0 || y + 1 == maxY()) {
                yDirectionRight = !yDirectionRight;
                if (y + 1 == maxY()) {
                    y -= 2;
                }
            }
            yChance += 60 * yChance;
        } else {
            if ((crypto.randomInt(Math.floor(xChance * 100))) / 100 < 1) {
                x = xDirectionRight ? (x + 1) : (x - 1);
                if (x == 0 || x + 1 == maxX()) {
                    xDirectionRight = !xDirectionRight;
                    if (x + 1 == maxX()) {
                        x -= 2;
                    }
                }
                xChance += .2;
            }
        }
    }
    return out;
}